<template>
  <div id="CrudHome">
    <div class="">
      <button
        type="button"
        class="btn btn-primary"
        data-toggle="modal"
        data-target="#ModalAdd"
        style="transform: translate(384px, -5px);"
      >
        ADD COSTUMER
      </button>

      <div class="col-sm-12">
        <v-data-table
          :headers="headers"
          :items="dt_customer"
          class="elevation-1"
        >
          <template class="bg-timeline" slot="items" scope="props">
            <tr v-bind:id="props.item.id">
              <td class="text-xs-left cursor" style="width: 70%;">
                {{ props.item.name }}
              </td>

              <td class="text-xs-left">
                <div class="row">
                  <v-icon
                    small
                    class="mr-2"
                    @click="getId(props.item.id)"
                    v-on:click="
                      getEdit(
                        props.item.name,
                        props.item.email,
                        props.item.is_married,
                        props.item.gender,
                        props.item.address,
                        props.item.password
                      )
                    "
                    data-toggle="modal"
                    data-target="#ModalEdit"
                  >
                    edit
                  </v-icon>
                  <form @submit="onSubmitDel">
                    <button @click="getId(props.item.id.toString())">
                      <v-icon small class="mr-2"> delete</v-icon>
                    </button>
                  </form>
                  <v-icon
                    small
                    @click="getId(props.item.id)"
                    v-on:click="
                      getEdit(
                        props.item.name,
                        props.item.email,
                        props.item.is_married,
                        props.item.gender,
                        props.item.address
                      )
                    "
                    data-toggle="modal"
                    data-target="#ModalDetail"
                    style="cursor: pointer;"
                  >
                    info</v-icon
                  >
                </div>
              </td>
            </tr>
          </template>
          <v-alert v-slot:no-results :value="true" color="error" icon="warning"
            >Your search for "{{ search }}" found no results.</v-alert
          >
        </v-data-table>
      </div>
    </div>

    <!-- Modal Add -->
    <div
      class="modal fade"
      id="ModalAdd"
      tabindex="-1"
      role="dialog"
      aria-labelledby="exampleModalLabel"
      aria-hidden="true"
    >
      <div class="modal-dialog" role="document">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="exampleModalLabel">Add Customer</h5>
            <button
              type="button"
              class="close"
              data-dismiss="modal"
              aria-label="Close"
            >
              <span aria-hidden="true">&times;</span>
            </button>
          </div>
          <div class="modal-body">
            <form @submit="onSubmitAddCS">
              <div class="form-group">
                <label for="recipient-name" class="col-form-label">Nama</label>
                <input
                  type="text"
                  class="form-control"
                  style="width: 100%;"
                  placeholder="Nama"
                  v-model.trim="custom_cr.name"
                  required
                />
              </div>
              <div class="form-group">
                <label for="recipient-name" class="col-form-label">Email</label>
                <input
                  type="text"
                  class="form-control"
                  style="width: 100%;"
                  placeholder="example@mail.com"
                  v-model.trim="custom_cr.email"
                  required
                />
              </div>
              <div class="form-group">
                <label for="recipient-name" class="col-form-label"
                  >Password</label
                >
                <input
                  :type="passwordFieldType"
                  class="form-control"
                  style="width: 80%;"
                  placeholder="Password"
                  v-model.trim="custom_cr.pwd"
                  required
                /><button
                  type="password"
                  @click="switchVisibility"
                  style="transform: translate(390px, -28px);"
                >
                  <v-icon small class="mr-2"> gavel</v-icon>
                </button>
              </div>
              <div class="form-group">
                <label for="recipient-name" class="col-form-label"
                  >Gender</label
                >
                <input
                  type="text"
                  class="form-control"
                  style="width: 100%;"
                  placeholder="Male or Female"
                  v-model.trim="custom_cr.gender"
                  required
                />
              </div>
              <div class="form-group">
                <label for="recipient-name" class="col-form-label"
                  >Status</label
                >
                <input
                  type="text"
                  class="form-control"
                  style="width: 100%;"
                  placeholder="Single or Married"
                  v-model.trim="custom_cr.sts"
                  required
                />
              </div>
              <div class="form-group">
                <label for="recipient-name" class="col-form-label"
                  >Address</label
                >
                <input
                  type="text"
                  class="form-control"
                  style="width: 100%;"
                  placeholder="Address"
                  v-model.trim="custom_cr.adrs"
                  required
                />
              </div>
              <div class="modal-footer">
                <button type="submit" class="btn btn-primary">Submit</button>
              </div>
            </form>
          </div>
        </div>
      </div>
    </div>
    <!-- End Modal Add -->

    <!-- Modal Edit -->
    <div
      class="modal fade"
      id="ModalEdit"
      tabindex="-1"
      role="dialog"
      aria-labelledby="exampleModalLabel"
      aria-hidden="true"
    >
      <div class="modal-dialog" role="document">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="exampleModalLabel">Edit Customer</h5>
            <button
              type="button"
              class="close"
              data-dismiss="modal"
              aria-label="Close"
            >
              <span aria-hidden="true">&times;</span>
            </button>
          </div>
          <div class="modal-body">
            <form @submit="onSubmitEdit">
              <div class="form-group">
                <label for="recipient-name" class="col-form-label">Nama</label>
                <input
                  type="text"
                  class="form-control"
                  style="width: 100%;"
                  placeholder="Nama"
                  v-model.trim="custom_ed.name"
                  required
                />
              </div>
              <div class="form-group">
                <label for="recipient-name" class="col-form-label">Email</label>
                <input
                  type="text"
                  class="form-control"
                  style="width: 100%;"
                  placeholder="example@mail.com"
                  v-model.trim="custom_ed.email"
                  required
                />
              </div>
              <div class="form-group">
                <label for="recipient-name" class="col-form-label"
                  >Password</label
                >
                <input
                  type="text"
                  class="form-control"
                  style="width: 100%;"
                  placeholder="Password"
                  v-model.trim="custom_ed.pwd"
                  required
                />
              </div>
              <div class="form-group">
                <label for="recipient-name" class="col-form-label"
                  >Gender</label
                >
                <input
                  type="text"
                  class="form-control"
                  style="width: 100%;"
                  placeholder="Male or Female"
                  v-model.trim="custom_ed.gender"
                  required
                />
              </div>
              <div class="form-group">
                <label for="recipient-name" class="col-form-label"
                  >Status</label
                >
                <input
                  type="text"
                  class="form-control"
                  style="width: 100%;"
                  placeholder="Single or Married"
                  v-model.trim="custom_ed.sts"
                  required
                />
              </div>
              <div class="form-group">
                <label for="recipient-name" class="col-form-label"
                  >Address</label
                >
                <input
                  type="text"
                  class="form-control"
                  style="width: 100%;"
                  placeholder="Address"
                  v-model.trim="custom_ed.adrs"
                  required
                />
              </div>
            </form>
          </div>
          <div class="modal-footer">
            <button type="button" class="btn btn-primary">Submit</button>
          </div>
        </div>
      </div>
    </div>
    <!-- End Modal Edit -->

    <!-- Modal Details -->
    <div
      class="modal fade"
      id="ModalDetail"
      data-backdrop="static"
      tabindex="-1"
      role="dialog"
      aria-labelledby="staticBackdropLabel"
      aria-hidden="true"
    >
      <div class="modal-dialog" role="document">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="staticBackdropLabel">
              Detail Customer
            </h5>
            <button
              type="button"
              class="close"
              data-dismiss="modal"
              aria-label="Close"
            >
              <span aria-hidden="true">&times;</span>
            </button>
          </div>
          <div class="modal-body">
            <div class="card mb-3" style="max-width: 540px;">
              <div class="row no-gutters">
                <div class="col-md-4">
                  <img src="../assets/imgDefault.png" class="card-img" />
                </div>
                <div class="col-md-8">
                  <div class="card-body">
                    <div>
                      <div>Nama: {{ custom_ed.name }}</div>
                      <div>Email: {{ custom_ed.email }}</div>
                      <div>Status: {{ custom_ed.sts }}</div>
                      <div>Gender: {{ custom_ed.gender }}</div>
                      <div>Address: {{ custom_ed.adrs }}</div>
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>
          <div class="modal-footer"></div>
        </div>
      </div>
    </div>
    <!-- End Modal Details -->
  </div>
</template>

<script>
import axios from "axios";

export default {
  name: "CrudHome",
  props: {
    msg: String
  },
  data() {
    return {
      dt_customer: [],
      custom_cr: {
        name: "",
        email: "",
        gender: "",
        sts: "",
        adrs: "",
        pwd: ""
      },
      custom_ed: {
        name: "",
        email: "",
        gender: "",
        sts: "",
        adrs: ""
      },
      password: "",
      passwordFieldType: "password",

      headers: [
        {
          text: "Nama",
          align: "left",
          sortable: true,
          value: "name"
        },

        { text: "Actions", value: "name", sortable: false }
      ]
    };
  },
  mounted() {
    axios.get("getCS/customers").then(response => {
      this.dt_customer = response.data["result"];
      console.log("data", this.dt_customer);
    });
  },
  methods: {
    onSubmitAddCS(evt) {
      evt.preventDefault();
      const data = {
        name: this.custom_cr.name,
        email: this.custom_cr.email,
        password: this.custom_cr.pwd,
        gender: this.custom_cr.gender,
        is_married: this.custom_cr.sts,
        address: this.custom_cr.adrs
      };
      console.log("data create", data);

      axios.post("getCS/customers", data).then(response => {
        console.log("response", response);
        if (response.status === "200") {
          this.alert = true;
          this.msgs = "success create customer";
        } else {
          this.msgs = "error create";
        }
        setTimeout(location.reload.bind(location), 3000);
      });
    },

    onSubmitEdit(evt) {
      evt.preventDefault();
      const data = {
        name: this.custom_cr.name,
        email: this.custom_cr.email,
        password: this.custom_cr.pwd,
        gender: this.custom_cr.gender,
        is_married: this.custom_cr.sts,
        address: this.custom_cr.adrs
      };
      console.log("data create", data);

      axios.put("getCS/customers", data).then(response => {
        console.log("response", response);
        if (response.status === "200") {
          this.alert = true;
          this.msgs = "success create customer";
        } else {
          this.msgs = "error create";
        }
        setTimeout(location.reload.bind(location), 3000);
      });
    },

    onSubmitDel(evt) {
      evt.preventDefault();
      const data = this.dt_customer.id;

      console.log("delete id", data);
      axios.delete("getCS/customers/" + data).then(response => {
        console.log("response delete", response);
        if (response.status === "200") {
          this.alert = true;
          this.msgs = "success delete customer";
        } else {
          this.msgs = "error delete";
        }
      });
    },

    getId(u) {
      this.dt_customer.id = u;
      console.log("id costumer", this.dt_customer.id);
    },
    getEdit(u, i, a, b, c) {
      this.custom_ed.name = u;
      this.custom_ed.email = i;
      this.custom_ed.gender = a;
      this.custom_ed.sts = b;
      this.custom_ed.adrs = c;
      console.log("data customer", this.custom_ed.name, this.custom_ed.email);
    },
    switchVisibility() {
      this.passwordFieldType =
        this.passwordFieldType === "password" ? "text" : "password";
    }
  }
};
</script>
